2 # ipkg - the itsy package management system
4 # Copyright (C) 2001 Carl D. Worth
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2, or (at your option)
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
18 # By default do not do globbing. Any command wanting globbing should
19 # explicitly enable it first and disable it afterwards.
24 A
=$
(echo $1 |
sed -r "s/([0-9]+)[^[:alnum:]]*/ \1 /g").
25 B
=$
(echo $2 |
sed -r "s/([0-9]+)[^[:alnum:]]*/ \1 /g").
26 while [ \
! -z "$A" ] && [ \
! -z "$B" ]; do {
27 set $A; a
=$1; shift; A
=$
*
28 set $B; b
=$1; shift; B
=$
*
29 [ "$a" -lt "$b" ] 2>&- && return 1
30 { [ "$a" -gt "$b" ] 2>&- ||
[ "$a" ">" "$b" ]; } && return
35 which md5sum 2>&1 >/dev
/null ||
alias md5sum=md5
39 sed -ne "s/^src[[:space:]]\+$srcre[[:space:]]\+//p" < $IPKG_CONF
43 sed -ne "s/^src[[:space:]]\+\([^[:space:]]\+\).*/\1/p" < $IPKG_CONF
48 ipkg_srcs
$src |
head -n 1
52 local destre
="`echo $1 | ipkg_protect_slashes`"
53 sed -ne "/^dest[[:space:]]\+$destre/{
54 s/^dest[[:space:]]\+[^[:space:]]\+[[:space:]]\+//
55 s/^/`echo $IPKG_OFFLINE_ROOT | ipkg_protect_slashes`/
61 sed -ne "s/^dest[[:space:]]\+\([^[:space:]]\+\).*/\1/p" < $IPKG_CONF
69 ipkg_dests_all |
sed "s|\$|/$IPKG_DIR_PREFIX|"
73 ipkg_dests_all |
head -n 1
76 ipkg_dest_default_name
() {
77 ipkg_dest_names |
head -n 1
82 ipkg_dests
$dest |
head -n 1
87 sed -ne "s/^option[[:space:]]\+$option[[:space:]]\+//p" < $IPKG_CONF
90 ipkg_load_configuration
() {
91 if [ -z "$IPKG_CONF_DIR" ]; then
95 IPKG_CONF
="$IPKG_CONF_DIR/ipkg.conf"
97 if [ -z "$IPKG_OFFLINE_ROOT" ]; then
98 IPKG_OFFLINE_ROOT
="`ipkg_option offline_root`"
100 # Export IPKG_OFFLINE_ROOT for use by update-alternatives
101 export IPKG_OFFLINE_ROOT
102 if [ -n "$DEST_NAME" ]; then
103 IPKG_ROOT
="`ipkg_dest_byname $DEST_NAME`"
104 if [ -z "$IPKG_ROOT" ]; then
105 if [ -d "$IPKG_OFFLINE_ROOT$DEST_NAME" ]; then
106 IPKG_ROOT
="$IPKG_OFFLINE_ROOT$DEST_NAME";
108 echo "ipkg: invalid destination specification: $DEST_NAME
109 Valid destinations are directories or one of the dest names from $IPKG_CONF:" >&2
115 IPKG_ROOT
="`ipkg_dest_default`"
118 # Global ipkg state directories
119 IPKG_DIR_PREFIX
=usr
/lib
/ipkg
120 IPKG_LISTS_DIR
=$IPKG_OFFLINE_ROOT/$IPKG_DIR_PREFIX/lists
121 IPKG_PENDING_DIR
=$IPKG_OFFLINE_ROOT/$IPKG_DIR_PREFIX/pending
122 if [ -z "$IPKG_TMP" ]; then
123 IPKG_TMP
=$IPKG_ROOT/tmp
/ipkg
126 [ -e "$IPKG_TMP" ] || mkdir
-p $IPKG_TMP
128 # Destination specific ipkg meta-data directory
129 IPKG_STATE_DIR
=$IPKG_ROOT/$IPKG_DIR_PREFIX
132 IPKG_PROXY_USERNAME
="`ipkg_option proxy_username`"
133 IPKG_PROXY_PASSWORD
="`ipkg_option proxy_password`"
134 IPKG_HTTP_PROXY
="`ipkg_option http_proxy`"
135 IPKG_FTP_PROXY
="`ipkg_option ftp_proxy`"
136 IPKG_NO_PROXY
="`ipkg_option no_proxy`"
137 if [ -n "$IPKG_HTTP_PROXY" ]; then
138 export http_proxy
="$IPKG_HTTP_PROXY"
141 if [ -n "$IPKG_FTP_PROXY" ]; then
142 export ftp_proxy
="$IPKG_FTP_PROXY"
145 if [ -n "$IPKG_NO_PROXY" ]; then
146 export no_proxy
="$IPKG_NO_PROXY"
149 IPKG_STATUS_FIELDS
='\(Package\|Status\|Essential\|Version\|Conffiles\|Root\)'
153 [ $# -gt 0 ] && echo "ipkg: $*"
155 usage: ipkg [options...] sub-command [arguments...]
156 where sub-command is one of:
158 Package Manipulation:
159 update Update list of available packages
160 upgrade Upgrade all installed packages to latest version
161 install <pkg> Download and install <pkg> (and dependencies)
162 install <file.ipk> Install package <file.ipk>
163 install <file.deb> Install package <file.deb>
164 remove <pkg> Remove package <pkg>
166 Informational Commands:
167 list List available packages and descriptions
168 files <pkg> List all files belonging to <pkg>
169 search <file> Search for a packaging providing <file>
170 info [pkg [<field>]] Display all/some info fields for <pkg> or all
171 status [pkg [<field>]] Display all/some status fields for <pkg> or all
172 depends <pkg> Print uninstalled package dependencies for <pkg>
175 -d <dest_name> Use <dest_name> as the the root directory for
176 -dest <dest_name> package installation, removal, upgrading.
177 <dest_name> should be a defined dest name from the
178 configuration file, (but can also be a directory
180 -o <offline_root> Use <offline_root> as the root for offline installation.
181 -offline <offline_root>
183 Force Options (use when ipkg is too smart for its own good):
184 -force-depends Make dependency checks warnings instead of errors
185 -force-defaults Use default options for questions asked by ipkg.
186 (no prompts). Note that this will not prevent
187 package installation scripts from prompting.
193 local dir
="`echo $1 | sed -ne 's/\(.*\/\).*/\1/p'`"
194 if [ -z "$dir" ]; then
201 echo $1 |
sed 's/.*\///'
204 ipkg_protect_slashes
() {
212 local src_file
="`ipkg_file_part $src`"
213 local dest_dir
="`ipkg_dir_part $dest`"
214 if [ -z "$dest_dir" ]; then
218 local dest_file
="`ipkg_file_part $dest`"
219 if [ -z "$dest_file" ]; then
220 dest_file
="$src_file"
225 local proxypassword
=""
228 if [ -n "$IPKG_PROXY_USERNAME" ]; then
229 proxyuser
="--proxy-user=\"$IPKG_PROXY_USERNAME\""
230 proxypassword
="--proxy-passwd=\"$IPKG_PROXY_PASSWORD\""
233 if [ -n "$IPKG_PROXY_HTTP" -o -n "$IPKG_PROXY_FTP" ]; then
234 proxyoption
="--proxy=on"
237 rm -f $IPKG_TMP/$src_file
240 if ! wget
--passive-ftp $proxyoption $proxyuser $proxypassword -P $IPKG_TMP $src; then
241 echo "ipkg_download: ERROR: Failed to retrieve $src, returning $err"
244 mv $IPKG_TMP/$src_file $dest_dir/$dest_file 2>/dev
/null
247 ln -s `echo $src | sed 's/^file://'` $dest_dir/$dest_file 2>/dev
/null
258 if [ ! -e "$IPKG_LISTS_DIR" ]; then
259 mkdir
-p $IPKG_LISTS_DIR
263 for src_name
in `ipkg_src_names`; do
264 local src
="`ipkg_src_byname $src_name`"
265 if ! ipkg_download
$src/Packages
$IPKG_LISTS_DIR/$src_name; then
266 echo "ipkg_update: Error downloading $src/Packages to $IPKG_LISTS_DIR/$src_name" >&2
269 echo "Updated list of available packages in $IPKG_LISTS_DIR/$src_name"
273 [ -n "$err" ] && return 1
279 for src
in `ipkg_src_names`; do
280 if ipkg_require_list
$src; then
284 s/^Package:[[:space:]]*\<\([a-z0-9.+-]*$1[a-z0-9.+-]*\).*/\1/
288 s/^Description:[[:space:]]*\(.*\)/\1/
295 " $IPKG_LISTS_DIR/$src
300 ipkg_extract_paragraph
() {
302 sed -ne "/Package:[[:space:]]*$pkg[[:space:]]*\$/,/^\$/p"
305 ipkg_extract_field
() {
325 ipkg_extract_value
() {
326 sed -e "s/^[^:]*:[[:space:]]*//"
329 ipkg_require_list
() {
330 [ $# -lt 1 ] && return 1
332 if [ ! -f "$IPKG_LISTS_DIR/$src" ]; then
333 echo "ERROR: File not found: $IPKG_LISTS_DIR/$src" >&2
334 echo " You probably want to run \`ipkg update'" >&2
341 for src
in `ipkg_src_names`; do
342 if ipkg_require_list
$src; then
345 cat $IPKG_LISTS_DIR/$src
348 ipkg_extract_paragraph
$1 < $IPKG_LISTS_DIR/$src
351 ipkg_extract_paragraph
$1 < $IPKG_LISTS_DIR/$src | ipkg_extract_field
$2
359 [ $# -lt 1 ] && return 0
362 if [ -f $sd/status
]; then
368 ipkg_extract_paragraph
$1 < $sd/status
371 ipkg_extract_paragraph
$1 < $sd/status | ipkg_extract_field
$2
379 for sd
in `ipkg_state_dirs`; do
380 ipkg_status_sd
$sd $
*
385 if [ -n "$DEST_NAME" ]; then
386 ipkg_status_sd
$IPKG_STATE_DIR $
*
392 ipkg_status_matching_sd
() {
395 if [ -f $sd/status
]; then
399 s/^Package:[[:space:]]*//
418 ipkg_status_matching_all
() {
419 for sd
in `ipkg_state_dirs`; do
420 ipkg_status_matching_sd
$sd $
*
424 ipkg_status_matching
() {
425 if [ -n "$DEST_NAME" ]; then
426 ipkg_status_matching_sd
$IPKG_STATE_DIR $
*
428 ipkg_status_matching_all $
*
432 ipkg_status_installed_sd
() {
435 ipkg_status_sd
$sd $pkg Status |
grep -q "Status: install ok installed"
438 ipkg_status_installed_all
() {
440 for sd
in `ipkg_state_dirs`; do
441 if `ipkg_status_installed_sd $sd $*`; then
448 ipkg_status_mentioned_sd
() {
451 [ -n "`ipkg_status_sd $sd $pkg Status`" ]
456 if [ -n "$DEST_NAME" ]; then
459 dests
="`ipkg_dests_all`"
461 for dest
in $dests; do
462 if [ -f $dest/$IPKG_DIR_PREFIX/info
/$pkg.list
]; then
463 dest_sed
="`echo $dest | ipkg_protect_slashes`"
464 sed -e "s/^/$dest_sed/" < $dest/$IPKG_DIR_PREFIX/info
/$pkg.list
472 for dest_name
in `ipkg_dest_names`; do
473 dest
="`ipkg_dest_byname $dest_name`"
474 dest_sed
="`echo $dest | ipkg_protect_slashes`"
477 local list_files
="`ls -1 $dest/$IPKG_DIR_PREFIX/info/*.list 2>/dev/null`"
479 for file in $list_files; do
480 if sed "s/^/$dest_sed/" $file |
grep -q $pattern; then
481 local pkg
="`echo $file | sed "s
/^.
*\
/\
(.
*\
)\.list
/\
1/"`"
482 [ "$dest_name" != `ipkg_dest_default_name` ] && pkg
="$pkg ($dest_name)"
483 sed "s/^/$dest_sed/" $file |
grep $pattern |
sed "s/^/$pkg: /"
489 ipkg_status_remove_sd
() {
493 if [ ! -f $sd/status
]; then
497 sed -ne "/Package:[[:space:]]*$pkg[[:space:]]*\$/,/^\$/!p" < $sd/status
> $sd/status.new
498 mv $sd/status.new
$sd/status
501 ipkg_status_remove_all
() {
502 for sd
in `ipkg_state_dirs`; do
503 ipkg_status_remove_sd
$sd $
*
507 ipkg_status_remove
() {
508 if [ -n "$DEST_NAME" ]; then
509 ipkg_status_remove_sd
$IPKG_STATE_DIR $
*
511 ipkg_status_remove_all $
*
515 ipkg_status_update_sd
() {
519 ipkg_status_remove_sd
$sd $pkg
520 ipkg_extract_field
"$IPKG_STATUS_FIELDS" >> $sd/status
521 echo "" >> $sd/status
524 ipkg_status_update
() {
525 ipkg_status_update_sd
$IPKG_STATE_DIR $
*
528 ipkg_unsatisfied_dependences
() {
530 local deps
="`ipkg_get_depends $pkg`"
531 local remaining_deps
=
533 local installed
="`ipkg_get_installed $dep`"
534 if [ "$installed" != "installed" ] ; then
535 remaining_deps
="$remaining_deps $dep"
538 ## echo "ipkg_unsatisfied_dependences pkg=$pkg $remaining_deps" > /dev/console
542 ipkg_safe_pkg_name
() {
544 local spkg
="`echo pkg_$pkg | sed -e y/-+./___/`"
551 pkg
="`ipkg_safe_pkg_name $pkg`"
552 ## setvar ${pkg}_depends "$new_deps"
553 echo $new_deps > $IPKG_TMP/${pkg}.depends
558 pkg
="`ipkg_safe_pkg_name $pkg`"
559 cat $IPKG_TMP/${pkg}.depends
560 ## eval "echo \$${pkg}_depends"
563 ipkg_set_installed
() {
565 pkg
="`ipkg_safe_pkg_name $pkg`"
566 echo installed
> $IPKG_TMP/${pkg}.installed
567 ## setvar ${pkg}_installed "installed"
570 ipkg_set_uninstalled
() {
572 pkg
="`ipkg_safe_pkg_name $pkg`"
573 ### echo ipkg_set_uninstalled $pkg > /dev/console
574 echo uninstalled
> $IPKG_TMP/${pkg}.installed
575 ## setvar ${pkg}_installed "uninstalled"
578 ipkg_get_installed
() {
580 pkg
="`ipkg_safe_pkg_name $pkg`"
581 if [ -f $IPKG_TMP/${pkg}.installed
]; then
582 cat $IPKG_TMP/${pkg}.installed
584 ## eval "echo \$${pkg}_installed"
590 local installed_pkgs
="`ipkg_status_matching_all 'Status:.*[[:space:]]installed'`"
591 for pkg
in $installed_pkgs; do
592 ipkg_set_installed
$pkg
594 while [ -n "$new_pkgs" ]; do
595 all_deps
="$all_deps $new_pkgs"
597 for pkg
in $new_pkgs; do
598 if echo $pkg |
grep -q '[^a-z0-9.+-]'; then
599 echo "ipkg_depends: ERROR: Package name $pkg contains illegal characters (should be [a-z0-9.+-])" >&2
602 # TODO: Fix this. For now I am ignoring versions and alternations in dependencies.
603 new_deps
="$new_deps "`ipkg_info $pkg '\(Pre-\)\?Depends' | ipkg_extract_value | sed -e 's/([^)]*)//g
604 s/\(|[[:space:]]*[a-z0-9.+-]\+[[:space:]]*\)\+//g
607 ipkg_set_depends
$pkg $new_deps
610 new_deps
=`echo $new_deps | sed -e 's/[[:space:]]\+/\n/g' | sort | uniq`
612 local maybe_new_pkgs
=
613 for pkg
in $new_deps; do
614 if ! echo $installed_pkgs |
grep -q "\<$pkg\>"; then
615 maybe_new_pkgs
="$maybe_new_pkgs $pkg"
620 for pkg
in $maybe_new_pkgs; do
621 if ! echo $all_deps |
grep -q "\<$pkg\>"; then
622 if [ -z "`ipkg_info $pkg`" ]; then
623 echo "ipkg_depends: Warning: $pkg mentioned in dependency but no package found in $IPKG_LISTS_DIR" >&2
624 ipkg_set_installed
$pkg
626 new_pkgs
="$new_pkgs $pkg"
627 ipkg_set_uninstalled
$pkg
630 ipkg_set_uninstalled
$pkg
638 ipkg_get_install_dest
() {
641 local sd
=$dest/$IPKG_DIR_PREFIX
642 local info_dir
=$sd/info
644 local requested_pkgs
="$*"
645 local pkgs
="`ipkg_depends $*`"
649 if ! ipkg_status_mentioned_sd
$sd $pkg; then
651 Status: install ok not-installed" | ipkg_status_update_sd
$sd $pkg
654 ## mark the packages that we were directly requested to install as uninstalled
655 for pkg
in $requested_pkgs; do ipkg_set_uninstalled
$pkg; done
658 local pkgs_installed
=0
659 while [ -n "pkgs" ]; do
661 ## echo "pkgs to install: {$pkgs}" > /dev/console
663 curcheck
="`expr $curcheck + 1`"
664 local is_installed
="`ipkg_get_installed $pkg`"
665 if [ "$is_installed" = "installed" ]; then
666 echo "$pkg is installed"
670 local remaining_deps
="`ipkg_unsatisfied_dependences $pkg`"
671 if [ -n "$remaining_deps" ]; then
672 new_pkgs
="$new_pkgs $pkg"
673 ### echo "Dependences not satisfied for $pkg: $remaining_deps"
674 if [ $curcheck -ne `echo $pkgs|wc -w` ]; then
680 for src
in `ipkg_src_names`; do
681 if ipkg_require_list
$src; then
682 filename
="`ipkg_extract_paragraph $pkg < $IPKG_LISTS_DIR/$src | ipkg_extract_field Filename | ipkg_extract_value`"
683 [ -n "$filename" ] && break
687 if [ -z "$filename" ]; then
688 echo "ipkg_get_install: ERROR: Cannot find package $pkg in $IPKG_LISTS_DIR"
689 echo "ipkg_get_install: Check the spelling and maybe run \`ipkg update'."
690 ipkg_status_remove_sd
$sd $pkg
694 local tmp_pkg_file
="$IPKG_TMP/"`ipkg_file_part $filename`
695 if ! ipkg_download
`ipkg_src_byname $src`/$filename $tmp_pkg_file; then
696 echo "ipkg_get_install: Perhaps you need to run \`ipkg update'?"
700 if ! ipkg_install_file_dest
$dest $tmp_pkg_file; then
701 echo "ipkg_get_install: ERROR: Failed to install $tmp_pkg_file"
702 echo "ipkg_get_install: I'll leave it there for you to try a manual installation"
706 ipkg_set_installed
$pkg
707 pkgs_installed
="`expr $pkgs_installed + 1`"
710 ### echo "Installed $pkgs_installed package(s) this round"
711 if [ $pkgs_installed -eq 0 ]; then
712 if [ -z "$new_pkgs" ]; then
724 ipkg_get_install_dest
$IPKG_ROOT $
*
727 ipkg_install_file_dest
() {
730 local sd
=$dest/$IPKG_DIR_PREFIX
731 local info_dir
=$sd/info
733 if [ ! -f "$filename" ]; then
734 echo "ipkg_install_file: ERROR: File $filename not found"
738 local pkg
="`ipkg_file_part $filename | sed 's/\([a-z0-9.+-]\+\)_.*/\1/'`"
739 local ext
="`echo $filename | sed 's/.*\.//'`"
740 local pkg_extract_stdout
741 if [ "$ext" = "ipk" ]; then
742 pkg_extract_stdout
="tar -xzOf"
743 elif [ "$ext" = "deb" ]; then
744 pkg_extract_stdout
="ar p"
746 echo "ipkg_install_file: ERROR: File $filename has unknown extension $ext (not .ipk or .deb)"
751 local depends
="`ipkg_depends $pkg | sed -e "s
/\
<$pkg\
>//"`"
753 # Don't worry about deps that are scheduled for installation
755 for dep
in $depends; do
756 if ! ipkg_status_all
$dep |
grep -q 'Status:[[:space:]]install'; then
757 missing_deps
="$missing_deps $dep"
761 if [ ! -z "$missing_deps" ]; then
762 if [ -n "$FORCE_DEPENDS" ]; then
763 echo "ipkg_install_file: Warning: $pkg depends on the following uninstalled programs: $missing_deps"
765 echo "ipkg_install_file: ERROR: $pkg depends on the following uninstalled programs:
767 echo "ipkg_install_file: You may want to use \`ipkg install' to install these."
772 mkdir
-p $IPKG_TMP/$pkg/control
773 mkdir
-p $IPKG_TMP/$pkg/data
776 if ! $pkg_extract_stdout $filename .
/control.
tar.gz |
(cd $IPKG_TMP/$pkg/control
; tar -xzf - ) ; then
777 echo "ipkg_install_file: ERROR unpacking control.tar.gz from $filename"
781 if [ -n "$IPKG_OFFLINE_ROOT" ]; then
782 if grep -q '^InstallsOffline:[[:space:]]*no' $IPKG_TMP/$pkg/control
/control
; then
783 echo "*** Warning: Package $pkg may not be installed in offline mode"
784 echo "*** Warning: Scheduling $filename for pending installation (installing into $IPKG_PENDING_DIR)"
786 Status: install ok pending" | ipkg_status_update_sd
$sd $pkg
787 mkdir
-p $IPKG_PENDING_DIR
788 cp -f $filename $IPKG_PENDING_DIR
789 rm -r $IPKG_TMP/$pkg/control
790 rm -r $IPKG_TMP/$pkg/data
797 echo -n "Unpacking $pkg..."
799 for file in $IPKG_TMP/$pkg/control
/*; do
800 local base_file
="`ipkg_file_part $file`"
801 mv $file $info_dir/$pkg.
$base_file
804 rm -r $IPKG_TMP/$pkg/control
806 if ! $pkg_extract_stdout $filename .
/data.
tar.gz |
(cd $IPKG_TMP/$pkg/data
; tar -xzf - ) ; then
807 echo "ipkg_install_file: ERROR unpacking data.tar.gz from $filename"
812 echo -n "Configuring $pkg..."
813 export PKG_ROOT
=$dest
814 if [ -x "$info_dir/$pkg.preinst" ]; then
815 if ! $info_dir/$pkg.preinst
install; then
816 echo "$info_dir/$pkg.preinst failed. Aborting installation of $pkg"
817 rm -rf $IPKG_TMP/$pkg/data
823 local old_conffiles
="`ipkg_status_sd $sd $pkg Conffiles | ipkg_extract_value`"
825 if [ -f "$info_dir/$pkg.conffiles" ]; then
826 for conffile
in `cat $info_dir/$pkg.conffiles`; do
827 if [ -f "$dest/$conffile" ] && ! echo " $old_conffiles " |
grep -q " $conffile "`md5sum $dest/$conffile | sed 's/ .*//'`; then
828 local use_maintainers_conffile
=
829 if [ -z "$FORCE_DEFAULTS" ]; then
831 echo -n "Configuration file \`$conffile'
832 ==> File on system created by you or by a script.
833 ==> File also in package provided by package maintainer.
834 What would you like to do about it ? Your options are:
835 Y or I : install the package maintainer's version
836 N or O : keep your currently-installed version
837 D : show the differences between the versions (if diff is installed)
838 The default action is to keep your current version.
839 *** `ipkg_file_part $conffile` (Y/I/N/O/D) [default=N] ? "
842 [YyIi
] |
[Yy
][Ee
][Ss
])
843 use_maintainers_conffile
=t
848 diff -u $dest/$conffile $IPKG_TMP/$pkg/data/$conffile"
849 diff -u $dest/$conffile $IPKG_TMP/$pkg/data
/$conffile || true
850 echo "[Press ENTER to continue]"
859 if [ -n "$use_maintainers_conffile" ]; then
860 local md5sum="`md5sum $IPKG_TMP/$pkg/data/$conffile | sed 's/ .*//'`"
861 new_conffiles
="$new_conffiles $conffile $md5sum"
863 new_conffiles
="$new_conffiles $conffile <custom>"
864 rm $IPKG_TMP/$pkg/data
/$conffile
867 md5sum="`md5sum $IPKG_TMP/$pkg/data/$conffile | sed 's/ .*//'`"
868 new_conffiles
="$new_conffiles $conffile $md5sum"
874 (cd $IPKG_TMP/$pkg/data
/; tar cf
- . |
(cd $owd; cd $dest; tar xf
-))
875 rm -rf $IPKG_TMP/$pkg/data
877 rm -f $info_dir/$pkg.list
878 $pkg_extract_stdout $filename .
/data.
tar.gz |
tar tzf
- |
sed -e 's/^\.//' > $info_dir/$pkg.list
880 if [ -x "$info_dir/$pkg.postinst" ]; then
881 $info_dir/$pkg.postinst configure
884 if [ -n "$new_conffiles" ]; then
885 new_conffiles
='Conffiles: '`echo $new_conffiles | ipkg_protect_slashes`
887 local sed_safe_offline_root
="`echo ${IPKG_OFFLINE_ROOT} | ipkg_protect_slashes`"
888 local sed_safe_root
="`echo $dest | sed -e "s
/^
${sed_safe_offline_root}//" | ipkg_protect_slashes`"
889 sed -e "s/\(Package:.*\)/\1\\
890 Status: install ok installed\\
891 Root: ${sed_safe_root}\\
892 ${new_conffiles}/" $info_dir/$pkg.control | ipkg_status_update_sd
$sd $pkg
894 rm -f $info_dir/$pkg.control
895 rm -f $info_dir/$pkg.conffiles
896 rm -f $info_dir/$pkg.preinst
897 rm -f $info_dir/$pkg.postinst
902 ipkg_install_file
() {
903 ipkg_install_file_dest
$IPKG_ROOT $
*
907 while [ $# -gt 0 ]; do
913 local tmp_pkg_file
="$IPKG_TMP/"`ipkg_file_part $pkg`
914 if ipkg_download
$pkg $tmp_pkg_file; then
915 ipkg_install_file
$tmp_pkg_file
919 file:/*.ipk |
file://*.deb
)
920 local ipkg_filename
="`echo $pkg|sed 's/^file://'`"
921 ipkg_install_file
$ipkg_filename
924 ipkg_install_file
$pkg
927 ipkg_get_install
$pkg || true
933 ipkg_install_pending
() {
934 [ -n "$IPKG_OFFLINE_ROOT" ] && return 0
936 if [ -d "$IPKG_PENDING_DIR" ]; then
938 local pending
="`ls -1d $IPKG_PENDING_DIR/*.ipk 2> /dev/null`" || true
940 if [ -n "$pending" ]; then
941 echo "The following packages in $IPKG_PENDING_DIR will now be installed:"
943 for filename
in $pending; do
944 if ipkg_install_file
$filename; then
953 ipkg_install_wanted
() {
954 local wanted
="`ipkg_status_matching 'Status:[[:space:]]*install.*not-installed'`"
956 if [ -n "$wanted" ]; then
957 echo "The following package were previously requested but have not been installed:"
960 if [ -n "$FORCE_DEFAULTS" ]; then
961 echo "Installing them now."
963 echo -n "Install them now [Y/n] ? "
980 local avail_ver
="`ipkg_info $pkg Version | ipkg_extract_value | head -n 1`"
983 for dest_name
in `ipkg_dest_names`; do
984 local dest
="`ipkg_dest_byname $dest_name`"
985 local sd
=$dest/$IPKG_DIR_PREFIX
986 local inst_ver
="`ipkg_status_sd $sd $pkg Version | ipkg_extract_value`"
987 if [ -n "$inst_ver" ]; then
990 if [ -z "$avail_ver" ]; then
991 echo "Assuming locally installed package $pkg ($inst_ver) is up to date"
995 if [ "$avail_ver" = "$inst_ver" ]; then
996 echo "Package $pkg ($inst_ver) installed in $dest_name is up to date"
997 elif ipkg_is_upgrade
"$avail_ver" "$inst_ver"; then
998 echo "Upgrading $pkg ($dest_name) from $inst_ver to $avail_ver"
999 ipkg_get_install_dest
$dest $pkg
1001 echo "Not downgrading package $pkg from $inst_ver to $avail_ver"
1006 if [ -z "$is_installed" ]; then
1007 echo "Package $pkg does not appear to be installed"
1014 if [ $# -lt 1 ]; then
1015 local pkgs
="`ipkg_status_matching 'Status:.*[[:space:]]installed'`"
1020 for pkg
in $pkgs; do
1021 ipkg_upgrade_pkg
$pkg
1025 ipkg_remove_pkg_dest
() {
1028 local sd
=$dest/$IPKG_DIR_PREFIX
1029 local info_dir
=$sd/info
1031 if ! ipkg_status_installed_sd
$sd $pkg; then
1032 echo "ipkg_remove: Package $pkg does not appear to be installed in $dest"
1033 if ipkg_status_mentioned_sd
$sd $pkg; then
1034 echo "Purging mention of $pkg from the ipkg database"
1035 ipkg_status_remove_sd
$sd $pkg
1040 echo "ipkg_remove: Removing $pkg... "
1042 local files
="`cat $info_dir/$pkg.list`"
1044 export PKG_ROOT
=$dest
1045 if [ -x "$info_dir/$pkg.prerm" ]; then
1046 $info_dir/$pkg.prerm remove
1049 local conffiles
="`ipkg_status_sd $sd $pkg Conffiles | ipkg_extract_value`"
1051 local dirs_to_remove
=
1052 for file in $files; do
1053 if [ -d "$dest/$file" ]; then
1054 dirs_to_remove
="$dirs_to_remove $dest/$file"
1056 if echo " $conffiles " |
grep -q " $file "; then
1057 if echo " $conffiles " |
grep -q " $file "`md5sum $dest/$file | sed 's/ .*//'`; then
1066 local removed_a_dir
=t
1067 while [ -n "$removed_a_dir" ]; do
1069 local new_dirs_to_remove
=
1070 for dir
in $dirs_to_remove; do
1071 if rmdir $dir >/dev
/null
2>&1; then
1074 new_dirs_to_remove
="$new_dirs_to_remove $dir"
1077 dirs_to_remove
="$new_dirs_to_remove"
1080 if [ -n "$dirs_to_remove" ]; then
1081 echo "ipkg_remove: Warning: Not removing the following directories since they are not empty:" >&2
1082 echo "$dirs_to_remove" |
sed -e 's/\/[/]\+/\//g' >&2
1085 if [ -x "$info_dir/$pkg.postrm" ]; then
1086 $info_dir/$pkg.postrm remove
1089 ipkg_status_remove_sd
$sd $pkg
1091 rm -f $info_dir/$pkg.
*
1099 for dest
in `ipkg_dests_all`; do
1100 local sd
=$dest/$IPKG_DIR_PREFIX
1101 if ipkg_status_mentioned_sd
$sd $pkg; then
1102 ipkg_remove_pkg_dest
$dest $pkg
1108 while [ $# -gt 0 ]; do
1111 if [ -n "$DEST_NAME" ]; then
1112 ipkg_remove_pkg_dest
$IPKG_ROOT $pkg
1114 ipkg_remove_pkg
$pkg
1124 while [ $# -gt 0 ]; do
1128 [ $# -gt 1 ] || ipkg_usage
"option $arg requires an argument"
1133 [ $# -gt 1 ] || ipkg_usage
"option $arg requires an argument"
1134 IPKG_OFFLINE_ROOT
="$2"
1144 ipkg_usage
"unknown option $arg"
1153 [ $# -lt 1 ] && ipkg_usage
"ipkg must have one sub-command argument"
1157 ipkg_load_configuration
1161 update|upgrade|list|info|status|install_pending
)
1163 install|depends|remove|files|search
)
1164 [ $# -lt 1 ] && ipkg_usage
"ERROR: the \`\`$cmd'' command requires an argument"
1167 echo "ERROR: unknown sub-command \`$cmd'"
1172 # Only install pending if we have an interactive sub-command
1175 ipkg_install_pending
1181 for a
in `ls $IPKG_TMP`; do